"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function debounce(fn, delay = 0, immediate) {
    let timerId, currArgs, context, result;
    const db = function (...args) {
        currArgs = args;
        context = this;
        if (immediate && timerId === undefined) {
            timerId = 0;
            result = fn.apply(context, currArgs);
        }
        clearTimeout(timerId);
        timerId = setTimeout(() => {
            if (!immediate && timerId) {
                result = fn.apply(context, currArgs);
            }
            timerId = undefined;
        }, delay);
        return result;
    };
    db.flush = function () {
        if (!immediate && timerId) {
            fn.apply(context, currArgs);
            timerId = undefined;
        }
    };
    db.cancel = function () {
        clearTimeout(timerId);
        timerId = undefined;
    };
    return db;
}
exports.default = debounce;
//# sourceMappingURL=index.js.map